<?php

/**
 * @file
 * Settings managment.
 */

/**
 * Form.
 */
function tmgmt_cdt_settings_form($form, &$form_state) {
  global $conf;

  if (variable_get('tmgmt_cdt_ready') === FALSE) {
    drupal_set_message(t('The current configuration is not ready: You must run the check <a href="@url" class="button form-submit" >Check</a>', array('@url' => url('admin/config/regional/tmgmt_cdt/check'))), 'warning', FALSE);
  }
  else {
    drupal_set_message(t('The current configuration is ready'), 'status', FALSE);
  }
  TmgmtCdtHelper::showStatus();

  $form = array();

  $form['group_mode'] = array(
    '#type' => 'fieldset',
    '#title' => t('Environment selection'),
    '#weight' => 10,
  );

  $form['group_mode']['api_mode'] = array(
    '#type' => 'select',
    '#default_value' => variable_get('tmgmt_cdt_api_mode'),
    '#options' => array(
      'SIMULATION' => t('Simulation (Not invoiced)'),
      'PRODUCTION' => t('Real (invoiced)'),
    ),
    '#required' => TRUE,
  );

  $form['group_production'] = array(
    '#type' => 'fieldset',
    '#title' => t('Web service'),
    '#weight' => 20,
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );

  $form['group_production']['api_url'] = array(
    '#type' => 'textfield',
    '#title' => t('Service url'),
    '#default_value' => variable_get('tmgmt_cdt_api_url', ''),
    '#size' => 80,
    '#maxlength' => 255,
  );
  $form['group_production']['api_user'] = array(
    '#type' => 'textfield',
    '#title' => t('Username'),

    '#default_value' => variable_get('tmgmt_cdt_api_username', ''),

    '#size' => 30,
    '#maxlength' => 50,
  );
  $form['group_production']['api_password'] = array(
    '#type' => 'password',
    '#title' => t('Password'),
    '#size' => 30,
    '#maxlength' => 50,
  );

  $form['group_advanced'] = array(
    '#type' => 'fieldset',
    '#title' => t('Advanced'),
    '#description' => '<strong>' . t('Please read the documentation carefully before changing these options') . '</strong><br><br>',
    '#weight' => 30,
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );

  $form['group_advanced']['use_token_html_a'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable tags <u><i>&lt;a&gt;</i></u> conversion.'),
    '#default_value' => variable_get('tmgmt_cdt_use_token_html_a') ? 1 : 0,
  );

  $form['group_advanced']['use_token_html_img'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable tags <u><i>&lt;img&gt;</i></u> conversion.'),
    '#default_value' => variable_get('tmgmt_cdt_use_token_html_img') ? 1 : 0,
  );

  $form['group_advanced']['use_token_html_script'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable tags <u><i>&lt;script&gt;</i></u> conversion. <strong>(Strongly recommended)</strong>'),
    '#default_value' => variable_get('tmgmt_cdt_use_token_html_script') ? 1 : 0,
  );

  $form['group_advanced']['use_token_drupal'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable Drupal tags like: <u><i>&lt;front&gt;, [[{&quot;fid&quot;: ..]], [token]</i></u> conversion. <strong>(Strongly recommended)</strong>'),
    '#default_value' => variable_get('tmgmt_cdt_use_token_drupal') ? 1 : 0,
  );

  $form['group_advanced']['html_check'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable html verification. <strong>(Strongly recommended)</strong>'),
    '#default_value' => variable_get('tmgmt_cdt_html_check') ? 1 : 0,
  );

  $form['group_advanced']['max_pages_per_request'] = array(
    '#type' => 'textfield',
    '#title' => t('Maximum number of pages per request'),
    '#default_value' => variable_get('tmgmt_cdt_max_pages_per_request'),
    '#size' => 5,
  );

  $form['group_advanced']['api_debug'] = array(
    '#type' => 'checkbox',
    '#title' => t('Log debugging information for API calls. 🚧'),
    '#default_value' => variable_get('tmgmt_cdt_debug') ? 1 : 0,
  );

  $form['group_advanced']['xsd_link'] = array(
    '#type' => 'textfield',
    '#title' => t('XSD Schema link.'),
    '#default_value' => variable_get('tmgmt_cdt_xsd_link'),
    '#size' => 150,
    '#maxlength' => 255,
  );

  $form['group_advanced']['disable_xsd_validation'] = array(
    '#type' => 'checkbox',
    '#title' => t('Disable XSD schema validation. <strong>(Not recommended)</strong>'),
    '#default_value' => variable_get('tmgmt_cdt_disable_xsd_validation') ? 1 : 0,
  );

  $form['group_advanced']['show_quotation'] = [
    '#type' => 'checkbox',
    '#title' => t('Show quotation option in checkout form'),
    '#default_value' => variable_get('tmgmt_cdt_show_quotation') ? 1 : 0,
  ];

  $form['group_network'] = array(
    '#type' => 'fieldset',
    '#title' => t('Network'),
    '#weight' => 40,
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );

  $form['group_network']['api_proxy_host'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy host'),
    '#default_value' => variable_get('tmgmt_cdt_curl_proxy_host', isset($conf['proxy_server']) ? trim($conf['proxy_server']) : NULL),
    '#size' => 30,
    '#maxlength' => 50,
  );

  $form['group_network']['api_proxy_port'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy port'),
    '#default_value' => variable_get('tmgmt_cdt_curl_proxy_port', isset($conf['proxy_port']) ? (int) $conf['proxy_port'] : NULL),
    '#size' => 5,
    '#maxlength' => 10,
  );

  $form['group_network']['api_proxy_user'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy username'),
    '#default_value' => variable_get('tmgmt_cdt_curl_proxy_user', isset($conf['proxy_username']) ? trim($conf['proxy_username']) : NULL),
    '#size' => 30,
    '#maxlength' => 50,
  );

  $proxy_password = variable_get('tmgmt_cdt_curl_proxy_pass', isset($conf['proxy_password']) ? trim($conf['proxy_password']) : NULL);
  variable_set('tmgmt_cdt_curl_proxy_pass', $proxy_password);

  $form['group_network']['api_proxy_pass'] = array(
    '#type' => 'password',
    '#title' => t('Proxy password'),
    '#size' => 30,
    '#maxlength' => 50,
  );

  $form['group_network']['api_proxy_user_agent'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy user agent'),
    '#default_value' => variable_get('tmgmt_cdt_curl_proxy_user_agent', isset($conf['proxy_user_agent']) ? trim($conf['proxy_user_agent']) : NULL),
    '#size' => 50,
    '#maxlength' => 255,
  );

  $form['group_network']['api_curl_options'] = array(
    '#type' => 'textarea',
    '#title' => t('CURL options.'),
    '#description' => t('JSON format.'),
    '#default_value' => variable_get('tmgmt_cdt_curl_options'),
    '#cols' => 50,
    '#rows' => 5,
  );

  $form['group_operations'] = array(
    '#type' => 'fieldset',
    '#title' => t('Operations'),
    '#weight' => 50,
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );

  $form['group_operations']['reset'] = array(
    '#type' => 'checkbox',
    '#title' => t('Reset all settings'),
    '#default_value' => 0,
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#weight' => 100,

  );

  return $form;
}

/**
 * On form submit.
 */
function tmgmt_cdt_settings_form_submit($form, &$form_state) {
  try {

    drupal_get_messages();

    if ($form_state['values']['reset'] === 1) {
      // Set default options.
      $options = TmgmtCdtHelper::defaultOptions();
      foreach ($options as $item => $value) {
        variable_set($item, $value);
      }
      @cache_clear_all('*', 'cache_variable', TRUE);
      return drupal_set_message(t('All settings deleted'), 'warning', FALSE);
    }

    // Mode.
    variable_set('tmgmt_cdt_api_mode', $form_state['values']['api_mode']);

    // Web service.
    variable_set('tmgmt_cdt_api_url', trim($form_state['values']['api_url']));
    variable_set('tmgmt_cdt_api_username', trim($form_state['values']['api_user']));
    if (drupal_strlen(trim($form_state['values']['api_password'])) > 0) {
      variable_set('tmgmt_cdt_api_password', base64_encode(trim($form_state['values']['api_password'])));
    }

    // Advanced.
    variable_set('tmgmt_cdt_use_token_html_a', $form_state['values']['use_token_html_a'] === 1 ? TRUE : FALSE);
    variable_set('tmgmt_cdt_use_token_html_img', $form_state['values']['use_token_html_img'] === 1 ? TRUE : FALSE);
    variable_set('tmgmt_cdt_use_token_html_script', $form_state['values']['use_token_html_script'] === 1 ? TRUE : FALSE);
    variable_set('tmgmt_cdt_use_token_drupal', $form_state['values']['use_token_drupal'] === 1 ? TRUE : FALSE);
    variable_set('tmgmt_cdt_use_token_drupal', $form_state['values']['use_token_drupal'] === 1 ? TRUE : FALSE);
    variable_set('tmgmt_cdt_html_check', $form_state['values']['html_check'] === 1 ? TRUE : FALSE);
    variable_set('tmgmt_cdt_max_pages_per_request', (int) $form_state['values']['max_pages_per_request']);
    variable_set('tmgmt_cdt_debug', $form_state['values']['api_debug'] === 1 ? TRUE : FALSE);

    variable_set('tmgmt_cdt_xsd_link', trim($form_state['values']['xsd_link']));
    $schema_source = TmgmtCdtHelper::curlGetFileContents(trim($form_state['values']['xsd_link']));
    if ($schema_source !== FALSE) {
      variable_set('tmgmt_cdt_xsd_source', $schema_source);
    }
    else {
      variable_set('tmgmt_cdt_xsd_source', '');
    }
    variable_set('tmgmt_cdt_disable_xsd_validation', $form_state['values']['disable_xsd_validation'] === 1 ? TRUE : FALSE);
    variable_set('tmgmt_cdt_show_quotation', $form_state['values']['show_quotation'] === 1 ? TRUE : FALSE);

    // Network.
    variable_set('tmgmt_cdt_curl_proxy_host', trim($form_state['values']['api_proxy_host']));
    variable_set('tmgmt_cdt_curl_proxy_port', trim($form_state['values']['api_proxy_port']));
    variable_set('tmgmt_cdt_curl_proxy_user', trim($form_state['values']['api_proxy_user']));
    if (drupal_strlen(trim($form_state['values']['api_proxy_pass'])) > 0) {
      variable_set('tmgmt_cdt_curl_proxy_pass', trim($form_state['values']['api_proxy_pass']));
    }
    variable_set('tmgmt_cdt_curl_proxy_user_agent', trim($form_state['values']['api_proxy_user_agent']));
    if (TmgmtCdtHelper::isJson(trim($form_state['values']['api_curl_options']))) {
      variable_set('tmgmt_cdt_curl_options', trim($form_state['values']['api_curl_options']));
    }
    else {
      return drupal_set_message(t('Wrong JSON format for Curl options'), 'error', FALSE);
    }
    // Messages.
    variable_set('tmgmt_cdt_ready', FALSE);
    drupal_set_message(t('Settings have been saved'), 'status', FALSE);

  }
  catch (\Exception $e) {
    drupal_set_message($e->getMessage(), 'error', FALSE);
  }
}

/**
 * Tmgmt_cdt_content_form.
 */
function tmgmt_cdt_content_form($form, &$form_state) {

  $translatable_fields = variable_get('tmgmt_cdt_translatable_fields');
  $form = array();

  $multilingual_content_type = tmgmt_cdt_translatable_content();

  $form['node'] = array(
    '#type' => 'fieldset',
    '#title' => t('Translatable fields for content types'),
  );

  if (!isset($multilingual_content_type['node'])) {
    $multilingual_content_type['node'] = array();
  }

  foreach ($multilingual_content_type['node'] as $node_data) {

    if (count($node_data['fields']) === 0) {
      continue;
    }

    $header = array(
      'field_name' => $node_data['label'] . '  <i>(' . $node_data['name'] . ')</i>',
    );

    $data = array();
    $default_value = array();
    foreach ($node_data['fields'] as $field_data) {

      $data[$field_data['name']] = array(
        'field_name' => $field_data['label'] . '  <i>(' . $field_data['name'] . ')</i>',
      );

      if (!isset($translatable_fields['node'][$node_data['name']][$field_data['name']])) {
        $default_value[$field_data['name']] = 0;
      }
      else {
        $default_value[$field_data['name']] = $translatable_fields['node'][$node_data['name']][$field_data['name']];
      }
    }

    if (count($data) > 0) {
      $form['node']['node@' . $node_data['name']] = array(
        '#type' => 'tableselect',
        '#header' => $header,
        '#options' => $data,
        '#default_value' => $default_value,
        '#empty' => t('No fields found'),
      );
    }
  }

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#weight' => 4,
  );
  return $form;
}

/**
 * On form submit.
 */
function tmgmt_cdt_content_form_submit($form, &$form_state) {

  try {
    $translatable_fields = array();
    foreach ($form_state['values'] as $type => $fields) {
      $content = explode('@', $type);

      if (count($content) !== 2) {
        continue;
      }
      $translatable_fields[$content[0]][$content[1]] = array();
      foreach ($fields as $field => $selected) {
        $translatable_fields[$content[0]][$content[1]][$field] = $selected === 0 ? 0 : 1;
      }
    }
    variable_set('tmgmt_cdt_translatable_fields', $translatable_fields);
    drupal_set_message(t('Saved'), 'status');
  }
  catch (\Exception $e) {
    drupal_set_message($e->getMessage(), 'error');
  }

}

/**
 * Check.
 */
function tmgmt_cdt_settings_check() {
  variable_set('tmgmt_cdt_ready', FALSE);
  variable_set('tmgmt_cdt_business_reference_data', '');
  variable_set('tmgmt_cdt_api_access_token_expire', 0);

  $is_ready = TRUE;

  try {
    drupal_set_message(t('Current environment: <strong>@mode</strong>.', array('@mode' => variable_get('tmgmt_cdt_api_mode'))), 'status', FALSE);

    $api = TmgmtCdtApi::getInstance();
    $api->setReady(TRUE);

    if ($api->checkConnection() === TRUE) {
      drupal_set_message(t('Test connection to CDT: <strong>OK</strong>.'), 'status', FALSE);
    }
    else {
      $is_ready = FALSE;
      drupal_set_message(t('Test connection to CDT: <strong>FAILED</strong>. @error',
        array(
          '@error' => implode(', ', $api->response->errors),
        )),
          'error', FALSE);
      throw new Exception();

    }

    // Check languages list.
    if (count(language_list()) > 1) {
      drupal_set_message(t('Language list: <strong>OK</strong>.'), 'status', FALSE);
    }
    else {
      $is_ready = FALSE;
      drupal_set_message(t('Language list: <strong>FAILED</strong>. @error', array('@error' => 'There must be at least 2 active languages.')), 'error', FALSE);
    }

    // Get business reference data.
    $api->resetInstance();
    $api->get('requests/businessReferenceData');
    if ($api->response->status === 'success') {
      variable_set('tmgmt_cdt_business_reference_data', $api->response->content);
      drupal_set_message(t('Store business reference data: <strong>OK</strong>.'), 'status', FALSE);
    }
    else {
      $is_ready = FALSE;
      drupal_set_message(t('Store business reference data: <strong>FAILED</strong>. @error',
        array(
          '@error' => implode(', ', $api->response->errors),
        )),
          'error', FALSE);
    }

    // Check languages mapping.
    $translator = tmgmt_translator_load('cdt');
    $errors_mapping_langs = array();
    $api_languages = @(array) variable_get('tmgmt_cdt_business_reference_data')->languages;

    foreach (locale_language_list() as $key => $lang) {
      if (!in_array($translator->mapToRemoteLanguage($key), $api_languages)) {
        $errors_mapping_langs[] = $lang;
      }
    }
    if (count($errors_mapping_langs) > 0) {
      $is_ready = FALSE;
      drupal_set_message(
            t('Languages mapping: <strong>FAILED</strong>. These languages must be mapped to the web service: @langs. <a href="@translators" target="_blank" >Translators list</a>', array(
              '@langs' => implode(', ', $errors_mapping_langs),
              '@translators' => url('admin/config/regional/tmgmt_translator'),
            )), 'error', FALSE);
    }
    else {
      drupal_set_message(t('Languages mapping: <strong>OK</strong>.'), 'status', FALSE);
    }

    // Check if there is at least one content type with multilingual.
    if (count(tmgmt_cdt_translatable_content()) > 0) {
      drupal_set_message(t('Content type with multilingual support: <strong>OK</strong>.'), 'status', FALSE);
    }
    else {
      $is_ready = FALSE;
      drupal_set_message(t('Content type with multilingual support: <strong>FAILED</strong>. @error', array('@error' => 'There must be at least one content type with a multilingual support enabled.')), 'error', FALSE);
    }

    // Jquery update.
    $jquery_admin_version = variable_get('jquery_update_jquery_admin_version', 0);
    if (version_compare($jquery_admin_version, '1.7', '>=')) {
      drupal_set_message(t('jQuery version for administrative pages <strong>OK</strong>.'), 'status', FALSE);
    }
    else {
      $is_ready = FALSE;
      drupal_set_message(t('jQuery version for administrative pages (jQuery update) must be > 1.7 (current version: @jquery_admin_version) <strong>FAILED</strong>. <a href="@jquery_settings" target="_blank" >jQuery update settings</a>',
        array(
          '@jquery_admin_version' => $jquery_admin_version,
          '@jquery_settings' => url('admin/config/development/jquery_update'),
        )), 'error', FALSE);
    }

    // Translator list.
    $translators = array();
    $cdt_position_saved = FALSE;

    foreach (entity_load_multiple_by_name('tmgmt_translator') as $id => $trans) {
      if ($trans->name === 'cdt' && $trans->weight !== 0) {
        $cdt_position_saved = TRUE;
      }
      $translators[] = $trans->name;
    }
    unset($id);

    if (in_array('cdt', array_values($translators))) {
      drupal_set_message(t('Translation Management Translators, CDT Translator <strong>OK</strong>.'), 'status', FALSE);
    }
    else {
      $is_ready = FALSE;
      drupal_set_message(t('Translation Management Translators, CDT Translator is missing. Please create one with machine name "cdt" <strong>FAILED</strong>.  <a href="@translators" target="_blank" >Translators list</a>', array('@translators' => url('admin/config/regional/tmgmt_translator'))), 'error', FALSE);
    }

    if (!$cdt_position_saved) {
      $is_ready = FALSE;
      drupal_set_message(t('Translation Management Translators list. Translator list must be saved to generate a weight position <strong>FAILED</strong>. <a href="@translators" target="_blank" >Translators list</a>', array('@translators' => url('admin/config/regional/tmgmt_translator'))), 'error', FALSE);
    }

    if (reset($translators) === 'cdt') {
      drupal_set_message(t('Translation Management Translators list <strong>OK</strong>.'), 'status', FALSE);
    }
    else {
      $is_ready = FALSE;
      drupal_set_message(t('Translation Management Translators list. CDT translator must be in first position (or is not configured) <strong>FAILED</strong>. <a href="@translators" target="_blank" >Translators list</a>', array('@translators' => url('admin/config/regional/tmgmt_translator'))), 'error', FALSE);
    }

    // Incompatible modules.
    $incompatible_list = array('tmgmt_poetry', 'tmgmt_dgt_html', 'ne_dgt_rules', 'ne_tmgmt_dgt_ftt_translator',
      'nexteuropa_dgt_connector', 'tmgmt_dgt_connector_cart', 'cdt_tmgmt', 'osha_tmgmt',
    );
    $to_disable = array();
    foreach ($incompatible_list as $module) {
      if (module_exists($module)) {
        $to_disable[] = $module;
      }
    }

    if (count($to_disable) === 0) {
      drupal_set_message(t('Incompatible modules <strong>OK</strong>.'), 'status', FALSE);
    }
    else {
      $is_ready = FALSE;
      $list_to_disable = implode(', ', $to_disable);
      drupal_set_message(t('Incompatible modules <strong>FAILED</strong>. These modules must be disabled: @list_to_disable.', array('@list_to_disable' => $list_to_disable)), 'error', FALSE);
    }

    if (!$is_ready) {
      throw new Exception();
    }

    variable_set('tmgmt_cdt_ready', TRUE);
    drupal_set_message(t('Module status: <strong>READY</strong>.'), 'status', FALSE);
  }
  catch (\Exception $e) {
    variable_set('tmgmt_cdt_ready', FALSE);

    drupal_set_message(t('Module status: <strong>NOT READY</strong>.'), 'error', FALSE);
    drupal_set_message(
          t('Check your settings and start again. <a href="@url" class="button form-submit" >Settings</a>', array('@url' => url('admin/config/regional/tmgmt_cdt/settings'))),
          'error',
          FALSE
      );
    TmgmtCdtHelper::showStatus(TRUE);
  }
}
